from ConfigParser import SafeConfigParser as ConfigParser
import mercurial.util as util
import os

# non existent file in repo, because file <-> section mapping
# may be enabled in the future
Section_ = '.hg/hgrc'
Config_file_ = '.hgflags'

def show_flags(ui, repo, *revs, **opts):
    '''Show all flags set in this repository
    
    If no specific flag is given, print all flags.
    If there is a flag given as parameter, check if it exists,
    and if not, print an error and exit with error.'''
    ff = os.path.join(os.path.dirname(repo.path),Config_file_)
    cp =  ConfigParser()
    cp.read(ff)
    if len(revs) == 0:      # list all flags
        ui.readsections(ff, Section_)
        for i in cp.items(Section_):
            print "%s = %s" % i
    elif len(revs) == 1:    # check specific flag
        try:
            tmp = cp.get(Section_, revs[0])
            print tmp
        except:
            raise util.Abort('unknown flag')
    else:
        raise util.Abort('wrong number of arguments')

def set_flag(ui, repo, *revs, **opts):
    '''Set flags for this repository

    If you want to remove a flag, just set it empty (e.g foo=).
    To set multiple flags: "hg flag foo=1 bar=2"'''
    ff = os.path.join(os.path.dirname(repo.path),Config_file_)
    cp =  ConfigParser()
    cp.read(ff)
    cp.has_section(Section_) or cp.add_section(Section_)
    # parse
    for i in revs:
        tmp = i.split('=')
        if len(tmp) != 2:
            raise util.Abort('invalied format: must be key=value')
        if tmp[1] == '':
            cp.remove_option(Section_, tmp[0])
        else:
            cp.set(Section_, tmp[0], tmp[1])
    # write and add
    fp = open(ff, "w")
    cp.write(fp)
    if not repo.dirstate.ignore(Config_file_) and repo.dirstate.state(Config_file_) == '?':
        repo.add([Config_file_])

cmdtable = {
    'flags': (show_flags, [], 'hg flags [<flag>]'),
    'flag' : (set_flag, [], "hg flag key=[<value>] ...")
    }
