import os
import urllib

from hgutil.util import QueueListBridge


def ishgrep(dir):
    return os.path.isdir(os.path.join(dir, '.hg'))

def iscleaned(repos):
    if len(os.listdir(repos)) == 1:
        return True
    else:
        return False

# from mercurial.util
def walkrepos(path):
    '''yield every hg repository under path, recursively.'''
    def errhandler(err):
        if err.filename == path:
            raise err

    for root, dirs, files in os.walk(path, onerror=errhandler):
        for d in dirs:
            if d == '.hg':
                yield root
                dirs[:] = []
                break

def walkrepos_flat(path):
    """yield every hg repository in the current directory"""
    if ishgrep(path):
        yield path
    for i in os.listdir(path):
        dir = os.path.join(path, i)
        if os.path.isdir(dir) and ishgrep(dir):
            yield dir

def walkrepos_web(url):
    data = urllib.urlopen(url + '/?style=raw')
    for i in data:
        i = i.strip("/\n")
        if len(i) > 0:
            yield url + "/" + i

def walkreposBase(func, q, path='.'):
    ql = QueueListBridge(q)
    for i in func(path):
        ql.append(i)

def walkreposFlat(q, path='.'):
    walkreposBase(walkrepos_flat, q, path)

def walkreposRecursiv(q, path='.'):
    walkreposBase(walkrepos, q, path)

def walkreposWeb(q, url):
    walkreposBase(walkrepos_web, q, path)

def walkreposConfigFile(q, path='.hgr'):
    ql = QueueListBridge(q)
    raise NotImplementedError()

